﻿workflow Ping
{
  param($computers, $mypath)

    #loop through each name/ip in input file
    foreach -parallel ($computer in $computers)
    {
        $status = Test-Connection -ComputerName $computer -Count 1 -Quiet

        if ($status)
            { 
                Add-Content -Path "$mypath\online.txt" -Value "$computer"
            }
    }
}

#define where I am working in the file system
$mypath=$MyInvocation.MyCommand.Path
$mypath=Split-Path $mypath -Parent

#clear previous results, if any
$myoutput=Test-Path -path $mypath\online.txt
if ($myoutput) {
   Clear-Content "$mypath\online.txt"
}

#presumes a file called offline.txt exists in current directory
$myinput=Test-Path -path $mypath\offline.txt
if ($myinput) {
    $mydevices=Get-Content $mypath\offline.txt
} else {
    write-host "No input file. Aborting.  Please create a text file of device names or IPs as $mypath\offline.txt"
    exit
}

$mytime=get-date -Format hh:mm:ss
Write-Host "`nSweep Beginning at: $mytime" -ForegroundColor Green

Ping $mydevices $mypath

$mytime=get-date -Format hh:mm:ss
Write-Host "`nSweep Ended at: $mytime" -ForegroundColor Green

#how many devices were found?
$count=Get-Content $mypath\online.txt | Measure-Object –Line

Write-Host "`nThere are $($count.lines) devices online. List stored in $mypath\online.txt" -BackgroundColor DarkGreen